#!/usr/bin/env python
# -*- coding: utf-8 -*-

##
## Copyright (c) 2016-2018 CPU and Fundamental Software Research Center, CAS
##
## This software is published by the license of CPU-OS License, you can use and
## distibuted this software under this License. See CPU-OS Liense for more detail.
##
## You should have receive a copy of CPU-OS License. If not, please contact us
## by email <support_os@cpu-os.ac.cn>
##
##

import dbus
import dbus.service
import sys,os
import dbus.mainloop.glib
import gobject
import logging

sys.path.append("/usr/lib/cdosupdate/")
from app import *

logging.basicConfig(level=logging.DEBUG, format='%(asctime)s %(filename)s %(levelname)s %(message)s',
                    filename='/tmp/myapp.log',filemode='w')

global dbus_name
global dbus_path
global dbus_iface
dbus_name="org.cdosupgrade"
dbus_path="/org/cdosupgrade"
dbus_iface="org.cdosupgrade"
#os.environ['DISPLAY'] = ':0'

class CdosUpgrade(dbus.service.Object):
    def __init__(self, conn=None, object_path=None, bus_name=None):
        logging.debug('In Constructor')
        self.bus = dbus.SystemBus()
        self.name = dbus.service.BusName(dbus_name, bus=self.bus)
        dbus.service.Object.__init__(self, self.name, dbus_path)

    @dbus.service.method(dbus_iface, in_signature='ssssss')
    def cdos_upgrade(self, tool, codename, local_path, backup_flag, xnumber, lang):
        logging.debug('begin upgrading')
        os.environ['DISPLAY'] = xnumber
        os.environ['LANG'] = lang
        command = "%s %s %s %s" % (tool, codename, local_path, backup_flag)
        logging.debug(command)
        os.system(command) 
        logging.debug("end upgrading")
        
    @dbus.service.method(dbus_iface, in_signature='')
    def cdos_reboot(self):
        os.system("reboot")


if __name__ == '__main__':
    dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
    loop = gobject.MainLoop()
    cdosupgrader = CdosUpgrade()
    loop.run()
    
